{
  pkgs,
  lib,
  ocaml-deps,
  buildDunePackage,
  version,
  debug ? false,
  doCheck ? false,
  ...
}:
buildDunePackage {
  pname = "culr";
  version = "0.1-vivid-${version}";

  minimalOCamlVersion = "5.2";

  src = ./..;
  nativeBuildInputs = [ pkgs.git ];
  buildInputs = ocaml-deps;

  buildPhase =
    if debug then
      ''
        runHook preBuild
        dune build -p culr --profile debug ''${enableParallelBuilding:+-j $NIX_BUILD_CORES}
        runHook postBuild
      ''
    else
      ''
        runHook preBuild
        dune build -p culr --profile release  ''${enableParallelBuilding:+-j $NIX_BUILD_CORES}
        runHook postBuild
      '';

  checkPhase = ''
    dune runtest
  '';
  inherit doCheck;

  meta.mainProgram = "culr";
}
